# rpmio/rpmsw.h File Reference

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | rpmsw_s
struct | rpmop_s
| Cumulative statistics for an operation. More...

## Typedefs

typedef unsigned long int | rpmtime_t
typedef struct rpmsw_s * | rpmsw
typedef struct rpmop_s * | rpmop

## Functions

rpmsw | rpmswNow (rpmsw sw)
| Return benchmark time stamp.
rpmtime_t | rpmswDiff (rpmsw end, rpmsw begin)
| Return benchmark time stamp difference.
rpmtime_t | rpmswInit (void)
| Return benchmark time stamp overhead.
int | rpmswEnter (rpmop op, ssize_t rc)
| Enter timed operation.
rpmtime_t | rpmswExit (rpmop op, ssize_t rc)
| Exit timed operation.
rpmtime_t | rpmswAdd (rpmop to, rpmop from)
| Sum statistic counters.
rpmtime_t | rpmswSub (rpmop to, rpmop from)
| Subtract statistic counters.

## Detailed Description

Definition in file rpmsw.h.

## Function Documentation

rpmtime_t rpmswDiff | ( | rpmsw | end,
|  | rpmsw | begin |
| ) |  |  |

Return benchmark time stamp difference.

Parameters:

  | *end | end time stamp
  | *begin | begin time stamp

Returns:
  difference in micro-seconds

Definition at line 119 of file rpmsw.c.

References rpmsw_cycles, rpmsw_overhead, rpmsw_type, rpmsw_s::ticks, rpmsw_s::tv, tvsub(), and rpmsw_s::u.

Referenced by rpmswExit(), and rpmswInit().

rpmtime_t rpmswInit | ( | void |  | ) |

Return benchmark time stamp overhead.

Returns:
  overhead in micro-seconds

Definition at line 176 of file rpmsw.c.

References rpmsw_cycles, rpmsw_initialized, rpmsw_overhead, rpmsw_type, rpmswDiff(), and rpmswNow().

Referenced by rpmswNow().

rpmsw rpmswNow | ( | rpmsw | sw | ) |

Return benchmark time stamp.

Parameters:

  | *sw | time stamp

Returns:
  0 on success

Definition at line 80 of file rpmsw.c.

References rpmsw_initialized, rpmsw_type, rpmswInit(), rpmsw_s::ticks, rpmsw_s::tv, and rpmsw_s::u.

Referenced by rpmswEnter(), rpmswExit(), and rpmswInit().